=== debian/changelog ===
primecount (7.2+ds-6) unstable; urgency=medium

  * Debianization:
    - d/patches/*:
      - d/p/upstream-cmake-enhance.patch, introduce;
    - d/rules:
      - override_dh_auto_install-indep target, stable machinery.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 13 Feb 2022 22:05:43 +0000

primecount (7.2+ds-5) unstable; urgency=medium

  * Team Upload.
  * d/rules: Fix build on arch-indep package
  * Add d/salsa-ci.yml

 -- Nilesh Patra <nilesh@debian.org>  Mon, 14 Feb 2022 00:44:45 +0530

primecount (7.2+ds-4) unstable; urgency=medium

  * Technical upload.
  * Debianization:
    - d/control:
      - primecount-doc package:
        - Suggests field, remove pdf-viewer.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 13 Feb 2022 17:23:33 +0000

primecount (7.2+ds-3) unstable; urgency=medium

  * Debianization:
    - d/copyright, address libdivide.h copyrights.

 -- Jerome Benoit <calculus@rezozer.net>  Wed, 09 Feb 2022 19:57:27 +0000

primecount (7.2+ds-2) unstable; urgency=medium

  * FTBFS fix: add libprimesieve-dev to Build-Depends.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 31 Jan 2022 10:43:53 +0000

primecount (7.2+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1003317)

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 30 Jan 2022 20:14:52 +0000
