=== debian/control ===
Source: primecount
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>
Section: math
Priority: optional
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (=13),
 cmake,
 libprimesieve-dev,
 asciidoc-base, xmlto
Build-Depends-Indep:
	pandoc
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/math-team/primecount.git
Vcs-Browser: https://salsa.debian.org/math-team/primecount
Homepage: https://github.com/kimwalisch/primecount

Package: primecount
Architecture: all
Multi-Arch: foreign
Depends: primecount-bin, ${misc:Depends}
Description: fast prime number counter C/C++ library
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This dummy package provides the standard installation.

Package: libprimecount7
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: primecount-bin (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libprimecount
Provides: libprimecount
Description: fast prime number counter C/C++ library -- lib
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the shared library.

Package: libprimecount-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libprimecount7 (= ${binary:Version}), libprimecount-dev-common (= ${source:Version}),
 libprimesieve-dev,
 ${misc:Depends}
Suggests: primecount-doc (= ${source:Version}), pkg-config
Conflicts: libprimecount-dev
Provides: libprimecount-dev
Description: fast prime number counter C/C++ library -- libdev
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the static library and symbolic links needed
 for development.

Package: libprimecount-dev-common
Architecture: all
Multi-Arch: foreign
Replaces: libprimecount7-dev-common
Breaks: libprimecount7-dev-common
Section: libdevel
Depends: ${misc:Depends}
Recommends: libprimecount-dev (= ${binary:Version})
Provides: libprimecount-dev-common
Description: fast prime number counter C/C++ library -- headers
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the headers needed by developers.

Package: primecount-bin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: primecount-doc (= ${source:Version})
Description: fast prime number counter C/C++ library -- bin
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 This package provides the command line utility primecount.

Package: primecount-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: www-browser
Enhances: primecount-bin (= ${binary:Version}), libprimecount-dev (= ${binary:Version})
Description: fast prime number counter C/C++ library -- doc
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the API documentation with its concomitant examples.
