=== debian/tests/control ===
Test-command: primecount --test

Tests: make-check-bin
Depends: primecount-bin

Tests: make-check-dev
Depends: libprimecount-dev, build-essential, pkg-config
Restrictions: allow-stderr

Tests: build-examples
Depends: primecount-doc, libprimecount-dev, build-essential, pkg-config
