## primecount 7.4+ds

=== debian/changelog ===
primecount (7.4+ds-1) unstable; urgency=medium

  * New usptream minor release.
  * Debianization:
    - d/control:
      - Standards-Version, bump to 4.6.1 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 10 Jul 2022 13:06:39 +0000

primecount (7.3+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/rules:
      - override_dh_auto_configure target, now build without POPCNT support;
    - d/patches/*:
      - d/p/upstream-cmake-enhance.patch, integrated;
     - lintin privacy-breach fix:
    	- d/adhoc/lintian/privacy-breach/www/images/*.svg, introduce
      - d/p/debianization-documentation.patch, introduce;
      - d/primecount-doc.links, introduce;
     	- d/{copyright,primecount-doc.docs} update.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 08 May 2022 14:22:52 +0000
