## primecount 7.6%2Bds

=== debian/control ===
--- 
+++ 
@@ -7,11 +7,11 @@
 Build-Depends:
  debhelper-compat (=13),
  cmake,
- libprimesieve-dev,
+ libprimesieve-dev (>=8.0),
  asciidoc-base, xmlto
 Build-Depends-Indep:
 	pandoc
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/math-team/primecount.git
 Vcs-Browser: https://salsa.debian.org/math-team/primecount
 Homepage: https://github.com/kimwalisch/primecount
