=== debian/changelog ===
primecount (7.6+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/tests/control, capitalize coomands.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 15 Dec 2022 18:47:24 +0000

primecount (7.4+ds-2) unstable; urgency=medium

  * Debianization:
    - d/watch, update;
    - d/s/lintian-overrides, update.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 27 Nov 2022 15:51:21 +0000
