=== debian/tests/control ===
--- 
+++ 
@@ -1,4 +1,4 @@
-Test-command: primecount --test
+Test-Command: primecount --test
 
 Tests: make-check-bin
 Depends: primecount-bin
