## primecount 7.9+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.22)
 project(primecount CXX)
 set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 6)
+set(PRIMECOUNT_VERSION_MINOR 9)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -17,7 +17,7 @@
 option(WITH_LIBDIVIDE       "Use libdivide.h"                       ON)
 option(WITH_OPENMP          "Enable OpenMP multi-threading"         ON)
 option(WITH_MSVC_CRT_STATIC "Link primecount.lib with /MT instead of the default /MD" OFF)
-option(WITH_FLOAT128        "Use __float128 (requires libquadmath)" OFF)
+option(WITH_FLOAT128        "Use __float128 (requires libquadmath), increases precision of Li(x) & RiemannR" OFF)
 option(WITH_JEMALLOC        "Use jemalloc allocator"                OFF)
 
 # When using WITH_DIV32=ON primecount checks at runtime
@@ -199,8 +199,11 @@
 # (e.g. libprimesieve-dev) and link against that version.
 
 if(BUILD_LIBPRIMESIEVE)
+    set(COPY_BUILD_EXAMPLES "${BUILD_EXAMPLES}")
     set(COPY_BUILD_MANPAGE "${BUILD_MANPAGE}")
     set(COPY_BUILD_TESTS "${BUILD_TESTS}")
+
+    set(BUILD_EXAMPLES OFF CACHE BOOL "Build example programs" FORCE)
     set(BUILD_MANPAGE OFF CACHE BOOL "Build primesieve manpage" FORCE)
     set(BUILD_TESTS OFF CACHE BOOL "Build primesieve tests" FORCE)
     option(BUILD_PRIMESIEVE "Build primesieve binary" OFF)
@@ -214,6 +217,7 @@
         target_compile_options(libprimesieve-static PRIVATE "${POPCNT_FLAG}")
     endif()
 
+    set(BUILD_EXAMPLES "${COPY_BUILD_EXAMPLES}" CACHE BOOL "Build example programs" FORCE)
     set(BUILD_MANPAGE "${COPY_BUILD_MANPAGE}" CACHE BOOL "Regenerate man page using a2x" FORCE)
     set(BUILD_TESTS "${COPY_BUILD_TESTS}" CACHE BOOL "Build test programs" FORCE)
 else()
@@ -307,10 +311,3 @@
 if(WITH_JEMALLOC)
     find_package(PkgConfig REQUIRED)
     pkg_check_modules(JEMALLOC jemalloc)
-    pkg_search_module(JEMALLOC REQUIRED jemalloc)
-
-    if(BUILD_PRIMECOUNT)
-        target_link_libraries(primecount PRIVATE ${JEMALLOC_LIBRARIES})
-        target_include_directories(primecount PRIVATE ${JEMALLOC_INCLUDE_DIRS})
-    endif()
-    if(BUILD_SHARED_LIBS)
