=== debian/changelog ===
primecount (7.9+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - copyright year-tuples, update;
    - d/control:
      - Standards-Version, bump to 4.6.2 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 17 Jul 2023 09:24:29 +0000
