=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  asciidoc-base, xmlto
 Build-Depends-Indep:
 	pandoc
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/math-team/primecount.git
 Vcs-Browser: https://salsa.debian.org/math-team/primecount
 Homepage: https://github.com/kimwalisch/primecount
