## primecount 7.10%2Bds

=== debian/changelog ===
primecount (7.10+ds-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:49:11 +0000

primecount (7.10+ds-1build1) noble; urgency=medium

  * No-change rebuild against libprimesieve12

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2024 07:35:02 +0000

primecount (7.10+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - copyright year-tuples, update.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 25 Jan 2024 17:04:37 +0000
