## primecount 7.10+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required(VERSION 3.4...3.22)
+cmake_minimum_required(VERSION 3.4...3.27)
 project(primecount CXX)
 set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 9)
+set(PRIMECOUNT_VERSION_MINOR 10)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -151,8 +151,8 @@
 endif()
 
 # Enable expensive debugging assertions.
-# These assertions enable e.g. bounds checks for the pod_vector
-# and pod_array types.
+# These assertions enable e.g. bounds checks
+# for the Vector and Array types.
 if(CMAKE_BUILD_TYPE STREQUAL "Debug")
     set(ENABLE_ASSERT "ENABLE_ASSERT")
 endif()
