## primecount 7.13+ds

=== debian/changelog ===
primecount (7.13+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/control:
      - Standards-Version, bump to 4.7.0 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 21 Apr 2024 13:03:33 +0000

primecount (7.12+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-fix-source-infinite_loops_on_i386.patch, obsoleted.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 05 Apr 2024 15:26:06 +0000

primecount (7.11+ds-2) unstable; urgency=medium

  * FTBFS on i386 arch fix release.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-fix-source-infinite_loops_on_i386.patch, import
        from upstream repositiry.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 22 Mar 2024 16:39:41 +0000

primecount (7.11+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - Files-Excluded list, refresh;
    - d{,/t}/control, rename pkg-config pkgconf.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 15 Mar 2024 13:00:06 +0000
