## primecount 7.14%2Bds

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: primecount
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
@@ -12,7 +11,7 @@
  asciidoc-base, xmlto
 Build-Depends-Indep:
 	pandoc
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/math-team/primecount.git
 Vcs-Browser: https://salsa.debian.org/math-team/primecount
 Homepage: https://github.com/kimwalisch/primecount
@@ -56,7 +55,7 @@
  libprimecount7 (= ${binary:Version}), libprimecount-dev-common (= ${source:Version}),
  libprimesieve-dev,
  ${misc:Depends}
-Suggests: primecount-doc (= ${source:Version}), pkg-config
+Suggests: primecount-doc (= ${source:Version}), pkgconf
 Conflicts: libprimecount-dev
 Provides: libprimecount-dev
 Description: fast prime number counter C/C++ library -- libdev
